<h1 id="octokit">Octokit</h1>
<p>Ruby toolkit for the GitHub API.</p>
<figure>
<img src="http://cl.ly/image/3Y013H0A2z3z/gundam-ruby.png" alt="logo" /><figcaption>logo</figcaption>
</figure>
<p>Upgrading? Check the <a href="#upgrading-guide">Upgrade Guide</a> before bumping to a new <a href="http://semver.org/">major version</a>.</p>
<h2 id="table-of-contents">Table of Contents</h2>
<ol type="1">
<li><a href="#philosophy">Philosophy</a></li>
<li><a href="#quick-start">Quick start</a></li>
<li><a href="#making-requests">Making requests</a></li>
<li><a href="#consuming-resources">Consuming resources</a></li>
<li><a href="#accessing-http-responses">Accessing HTTP responses</a></li>
<li><a href="#authentication">Authentication</a>
<ol type="1">
<li><a href="#basic-authentication">Basic Authentication</a></li>
<li><a href="#oauth-access-tokens">OAuth access tokens</a></li>
<li><a href="#two-factor-authentication">Two-Factor Authentication</a></li>
<li><a href="#using-a-netrc-file">Using a .netrc file</a></li>
<li><a href="#application-authentication">Application authentication</a></li>
</ol></li>
<li><a href="#pagination">Pagination</a>
<ol type="1">
<li><a href="#auto-pagination">Auto pagination</a></li>
</ol></li>
<li><a href="#working-with-github-enterprise">Working with GitHub Enterprise</a>
<ol type="1">
<li><a href="#interacting-with-the-githubcom-apis-in-github-enterprise">Interacting with the GitHub.com APIs in GitHub Enterprise</a></li>
<li><a href="#interacting-with-the-github-enterprise-admin-apis">Interacting with the GitHub Enterprise Admin APIs</a></li>
<li><a href="#interacting-with-the-github-enterprise-management-console-apis">Interacting with the GitHub Enterprise Management Console APIs</a></li>
</ol></li>
<li><a href="#ssl-connection-errors">SSL Connection Errors</a></li>
<li><a href="#configuration-and-defaults">Configuration and defaults</a>
<ol type="1">
<li><a href="#configuring-module-defaults">Configuring module defaults</a></li>
<li><a href="#using-env-variables">Using ENV variables</a></li>
</ol></li>
<li><a href="#hypermedia-agent">Hypermedia agent</a>
<ol type="1">
<li><a href="#hypermedia-in-octokit">Hypermedia in Octokit</a></li>
<li><a href="#uri-templates">URI templates</a></li>
<li><a href="#the-full-hypermedia-experience">The Full Hypermedia Experience™</a></li>
</ol></li>
<li><a href="#upgrading-guide">Upgrading guide</a>
<ol type="1">
<li><a href="#upgrading-from-1xx">Upgrading from 1.x.x</a></li>
</ol></li>
<li><a href="#advanced-usage">Advanced usage</a>
<ol type="1">
<li><a href="#debugging">Debugging</a></li>
<li><a href="#caching">Caching</a></li>
</ol></li>
<li><a href="#hacking-on-octokitrb">Hacking on Octokit.rb</a>
<ol type="1">
<li><a href="#running-and-writing-new-tests">Running and writing new tests</a></li>
</ol></li>
<li><a href="#supported-ruby-versions">Supported Ruby Versions</a></li>
<li><a href="#versioning">Versioning</a></li>
<li><a href="#making-repeating-requests">Making Repeating Requests</a></li>
<li><a href="#license">License</a></li>
</ol>
<h2 id="philosophy">Philosophy</h2>
<p>API wrappers <a href="http://wynnnetherland.com/journal/what-makes-a-good-api-wrapper">should reflect the idioms of the language in which they were written</a>. Octokit.rb wraps the <a href="http://developer.github.com">GitHub API</a> in a flat API client that follows Ruby conventions and requires little knowledge of REST. Most methods have positional arguments for required input and an options hash for optional parameters, headers, or other options:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb1-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new</a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co"># Fetch a README with Accept header for HTML format</span></a>
<a class="sourceLine" id="cb1-4" title="4">client.readme <span class="st">&#39;al3x/sovereign&#39;</span>, <span class="st">:accept</span> =&gt; <span class="st">&#39;application/vnd.github.html&#39;</span></a></code></pre></div>
<h2 id="quick-start">Quick start</h2>
<p>Install via Rubygems</p>
<pre><code>gem install octokit</code></pre>
<p>… or add to your Gemfile</p>
<pre><code>gem &quot;octokit&quot;, &quot;~&gt; 4.0&quot;</code></pre>
<p>Access the library in Ruby:</p>
<pre><code>require &#39;octokit&#39;</code></pre>
<h3 id="making-requests">Making requests</h3>
<p><a href="http://octokit.github.io/octokit.rb/method_list.html">API methods</a> are available as client instance methods.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb5-1" title="1"><span class="co"># Provide authentication credentials</span></a>
<a class="sourceLine" id="cb5-2" title="2">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:login</span> =&gt; <span class="st">&#39;defunkt&#39;</span>, <span class="st">:password</span> =&gt; <span class="st">&#39;c0d3b4ssssss!&#39;</span>)</a>
<a class="sourceLine" id="cb5-3" title="3"></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="co"># Set access_token instead of login and password if you use personal access token</span></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="co"># client = Octokit::Client.new(:access_token =&gt; &#39;[personal_access_token]!&#39;)</span></a>
<a class="sourceLine" id="cb5-6" title="6"></a>
<a class="sourceLine" id="cb5-7" title="7"><span class="co"># Fetch the current user</span></a>
<a class="sourceLine" id="cb5-8" title="8">client.user</a></code></pre></div>
<h3 id="additional-query-parameters">Additional Query Parameters</h3>
<p>When passing additional parameters to GET based request use the following syntax:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb6-1" title="1"> <span class="co"># query: { parameter_name: &#39;value&#39; }</span></a>
<a class="sourceLine" id="cb6-2" title="2"> <span class="co"># Example: Get repository listing by owner in ascending order</span></a>
<a class="sourceLine" id="cb6-3" title="3"> client.repos({}, <span class="st">query: </span>{<span class="st">type: &#39;owner&#39;</span>, <span class="st">sort: &#39;asc&#39;</span>})</a>
<a class="sourceLine" id="cb6-4" title="4"></a>
<a class="sourceLine" id="cb6-5" title="5"> <span class="co"># Example: Get contents of a repository by ref</span></a>
<a class="sourceLine" id="cb6-6" title="6"> <span class="co"># https://api.github.com/repos/octokit/octokit.rb/contents/path/to/file.rb?ref=some-other-branch</span></a>
<a class="sourceLine" id="cb6-7" title="7"> client.contents(<span class="st">&#39;octokit/octokit.rb&#39;</span>, <span class="st">path: &#39;path/to/file.rb&#39;</span>, <span class="st">query: </span>{<span class="st">ref: &#39;some-other-branch&#39;</span>})</a></code></pre></div>
<h3 id="consuming-resources">Consuming resources</h3>
<p>Most methods return a <code>Resource</code> object which provides dot notation and <code>[]</code> access for fields returned in the API response.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb7-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new</a>
<a class="sourceLine" id="cb7-2" title="2"></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="co"># Fetch a user</span></a>
<a class="sourceLine" id="cb7-4" title="4">user = client.user <span class="st">&#39;jbarnette&#39;</span></a>
<a class="sourceLine" id="cb7-5" title="5">puts user.name</a>
<a class="sourceLine" id="cb7-6" title="6"><span class="co"># =&gt; &quot;John Barnette&quot;</span></a>
<a class="sourceLine" id="cb7-7" title="7">puts user.fields</a>
<a class="sourceLine" id="cb7-8" title="8"><span class="co"># =&gt; &lt;Set: {:login, :id, :gravatar_id, :type, :name, :company, :blog, :location, :email, :hireable, :bio, :public_repos, :followers, :following, :created_at, :updated_at, :public_gists}&gt;</span></a>
<a class="sourceLine" id="cb7-9" title="9">puts user[<span class="st">:company</span>]</a>
<a class="sourceLine" id="cb7-10" title="10"><span class="co"># =&gt; &quot;GitHub&quot;</span></a>
<a class="sourceLine" id="cb7-11" title="11">user.rels[<span class="st">:gists</span>].href</a>
<a class="sourceLine" id="cb7-12" title="12"><span class="co"># =&gt; &quot;https://api.github.com/users/jbarnette/gists&quot;</span></a></code></pre></div>
<p><strong>Note:</strong> URL fields are culled into a separate <code>.rels</code> collection for easier <a href="#hypermedia-agent">Hypermedia</a> support.</p>
<h3 id="accessing-http-responses">Accessing HTTP responses</h3>
<p>While most methods return a <code>Resource</code> object or a Boolean, sometimes you may need access to the raw HTTP response headers. You can access the last HTTP response with <code>Client#last_response</code>:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb8-1" title="1">user      = client.user <span class="st">&#39;andrewpthorp&#39;</span></a>
<a class="sourceLine" id="cb8-2" title="2">response  = client.last_response</a>
<a class="sourceLine" id="cb8-3" title="3">etag      = response.headers[<span class="st">:etag</span>]</a></code></pre></div>
<h2 id="authentication">Authentication</h2>
<p>Octokit supports the various <a href="http://developer.github.com/v3/#authentication">authentication methods supported by the GitHub API</a>:</p>
<h3 id="basic-authentication">Basic Authentication</h3>
<p>Using your GitHub username and password is the easiest way to get started making authenticated requests:</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb9-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:login</span> =&gt; <span class="st">&#39;defunkt&#39;</span>, <span class="st">:password</span> =&gt; <span class="st">&#39;c0d3b4ssssss!&#39;</span>)</a>
<a class="sourceLine" id="cb9-2" title="2"></a>
<a class="sourceLine" id="cb9-3" title="3">user = client.user</a>
<a class="sourceLine" id="cb9-4" title="4">user.login</a>
<a class="sourceLine" id="cb9-5" title="5"><span class="co"># =&gt; &quot;defunkt&quot;</span></a></code></pre></div>
<p>While Basic Authentication allows you to get started quickly, OAuth access tokens are the preferred way to authenticate on behalf of users.</p>
<h3 id="oauth-access-tokens">OAuth access tokens</h3>
<p><a href="http://developer.github.com/v3/oauth/">OAuth access tokens</a> provide two main benefits over using your username and password:</p>
<ul>
<li><strong>Revokable access</strong>. Access tokens can be revoked, removing access for only that token without having to change your password everywhere.</li>
<li><strong>Limited access</strong>. Access tokens have <a href="http://developer.github.com/v3/oauth/#scopes">access scopes</a> which allow for more granular access to API resources. For instance, you can grant a third party access to your gists but not your private repositories.</li>
</ul>
<p>To use an access token with the Octokit client, pass your token in the <code>:access_token</code> options parameter in lieu of your username and password:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb10-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:access_token</span> =&gt; <span class="st">&quot;&lt;your 40 char token&gt;&quot;</span>)</a>
<a class="sourceLine" id="cb10-2" title="2"></a>
<a class="sourceLine" id="cb10-3" title="3">user = client.user</a>
<a class="sourceLine" id="cb10-4" title="4">user.login</a>
<a class="sourceLine" id="cb10-5" title="5"><span class="co"># =&gt; &quot;defunkt&quot;</span></a></code></pre></div>
<p>You can <a href="https://help.github.com/articles/creating-an-access-token-for-command-line-use">create access tokens through your GitHub Account Settings</a> or with a basic authenticated Octokit client:</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb11-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:login</span> =&gt; <span class="st">&#39;defunkt&#39;</span>, <span class="st">:password</span> =&gt; <span class="st">&#39;c0d3b4ssssss!&#39;</span>)</a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3">client.create_authorization(<span class="st">:scopes</span> =&gt; [<span class="st">&quot;user&quot;</span>], <span class="st">:note</span> =&gt; <span class="st">&quot;Name of token&quot;</span>)</a>
<a class="sourceLine" id="cb11-4" title="4"><span class="co"># =&gt; &lt;your new oauth token&gt;</span></a></code></pre></div>
<h3 id="two-factor-authentication">Two-Factor Authentication</h3>
<p><a href="https://help.github.com/articles/about-two-factor-authentication">Two-Factor Authentication</a> brings added security to the account by requiring more information to login.</p>
<p>Using two-factor authentication for API calls is as simple as adding the <a href="http://developer.github.com/v3/auth/#working-with-two-factor-authentication">required header</a> as an option:</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb12-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new \</a>
<a class="sourceLine" id="cb12-2" title="2">  <span class="st">:login</span>    =&gt; <span class="st">&#39;defunkt&#39;</span>,</a>
<a class="sourceLine" id="cb12-3" title="3">  <span class="st">:password</span> =&gt; <span class="st">&#39;c0d3b4ssssss!&#39;</span></a>
<a class="sourceLine" id="cb12-4" title="4"></a>
<a class="sourceLine" id="cb12-5" title="5">user = client.user(<span class="st">&quot;defunkt&quot;</span>, <span class="st">:headers</span> =&gt; { <span class="st">&quot;X-GitHub-OTP&quot;</span> =&gt; <span class="st">&quot;&lt;your 2FA token&gt;&quot;</span> })</a></code></pre></div>
<p>As you can imagine, this gets annoying quick since two-factor auth tokens are very short lived. So it is recommended to create an oauth token for the user to communicate with the API:</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb13-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new \</a>
<a class="sourceLine" id="cb13-2" title="2">  <span class="st">:login</span>    =&gt; <span class="st">&#39;defunkt&#39;</span>,</a>
<a class="sourceLine" id="cb13-3" title="3">  <span class="st">:password</span> =&gt; <span class="st">&#39;c0d3b4ssssss!&#39;</span></a>
<a class="sourceLine" id="cb13-4" title="4"></a>
<a class="sourceLine" id="cb13-5" title="5">client.create_authorization(<span class="st">:scopes</span> =&gt; [<span class="st">&quot;user&quot;</span>], <span class="st">:note</span> =&gt; <span class="st">&quot;Name of token&quot;</span>,</a>
<a class="sourceLine" id="cb13-6" title="6">                            <span class="st">:headers</span> =&gt; { <span class="st">&quot;X-GitHub-OTP&quot;</span> =&gt; <span class="st">&quot;&lt;your 2FA token&gt;&quot;</span> })</a>
<a class="sourceLine" id="cb13-7" title="7"><span class="co"># =&gt; &lt;your new oauth token&gt;</span></a></code></pre></div>
<h3 id="using-a-.netrc-file">Using a .netrc file</h3>
<p>Octokit supports reading credentials from a netrc file (defaulting to <code>~/.netrc</code>). Given these lines in your netrc:</p>
<pre><code>machine api.github.com
  login defunkt
  password c0d3b4ssssss!</code></pre>
<p>You can now create a client with those credentials:</p>
<div class="sourceCode" id="cb15"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb15-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:netrc</span> =&gt; <span class="dv">true</span>)</a>
<a class="sourceLine" id="cb15-2" title="2">client.login</a>
<a class="sourceLine" id="cb15-3" title="3"><span class="co"># =&gt; &quot;defunkt&quot;</span></a></code></pre></div>
<p>But <em>I want to use OAuth</em> you say. Since the GitHub API supports using an OAuth token as a Basic password, you totally can:</p>
<pre><code>machine api.github.com
  login defunkt
  password &lt;your 40 char token&gt;</code></pre>
<p><strong>Note:</strong> Support for netrc requires adding the <a href="https://rubygems.org/gems/netrc">netrc gem</a> to your Gemfile or <code>.gemspec</code>.</p>
<h3 id="application-authentication">Application authentication</h3>
<p>Octokit also supports application-only authentication <a href="http://developer.github.com/v3/#increasing-the-unauthenticated-rate-limit-for-oauth-applications">using OAuth application client credentials</a>. Using application credentials will result in making anonymous API calls on behalf of an application in order to take advantage of the higher rate limit.</p>
<div class="sourceCode" id="cb17"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb17-1" title="1">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new \</a>
<a class="sourceLine" id="cb17-2" title="2">  <span class="st">:client_id</span>     =&gt; <span class="st">&quot;&lt;your 20 char id&gt;&quot;</span>,</a>
<a class="sourceLine" id="cb17-3" title="3">  <span class="st">:client_secret</span> =&gt; <span class="st">&quot;&lt;your 40 char secret&gt;&quot;</span></a>
<a class="sourceLine" id="cb17-4" title="4"></a>
<a class="sourceLine" id="cb17-5" title="5">user = client.user <span class="st">&#39;defunkt&#39;</span></a></code></pre></div>
<h2 id="default-results-per_page">Default results per_page</h2>
<p>Default results from the GitHub API are 30, if you wish to add more you must do so during Octokit configuration.</p>
<div class="sourceCode" id="cb18"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb18-1" title="1"><span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">access_token: &quot;&lt;your 40 char token&gt;&quot;</span>, <span class="st">per_page: </span><span class="dv">100</span>)</a></code></pre></div>
<h2 id="pagination">Pagination</h2>
<p>Many GitHub API resources are <a href="http://developer.github.com/v3/#pagination">paginated</a>. While you may be tempted to start adding <code>:page</code> parameters to your calls, the API returns links to the next, previous, and last pages for you in the <code>Link</code> response header as <a href="#hypermedia-agent">Hypermedia link relations</a>.</p>
<div class="sourceCode" id="cb19"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb19-1" title="1">issues = client.issues <span class="st">&#39;rails/rails&#39;</span></a>
<a class="sourceLine" id="cb19-2" title="2">issues.concat client.last_response.rels[<span class="st">:next</span>].get.data</a></code></pre></div>
<h3 id="auto-pagination">Auto pagination</h3>
<p>For smallish resource lists, Octokit provides auto pagination. When this is enabled, calls for paginated resources will fetch and concatenate the results from every page into a single array:</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb20-1" title="1">client.auto_paginate = <span class="dv">true</span></a>
<a class="sourceLine" id="cb20-2" title="2">issues = client.issues <span class="st">&#39;rails/rails&#39;</span></a>
<a class="sourceLine" id="cb20-3" title="3">issues.length</a>
<a class="sourceLine" id="cb20-4" title="4"></a>
<a class="sourceLine" id="cb20-5" title="5"><span class="co"># =&gt; 702</span></a></code></pre></div>
<p>You can also enable auto pagination for all Octokit client instances:</p>
<div class="sourceCode" id="cb21"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb21-1" title="1"><span class="dt">Octokit</span>.configure <span class="kw">do</span> |c|</a>
<a class="sourceLine" id="cb21-2" title="2">  c.auto_paginate = <span class="dv">true</span></a>
<a class="sourceLine" id="cb21-3" title="3"><span class="kw">end</span></a></code></pre></div>
<p><strong>Note:</strong> While Octokit auto pagination will set the page size to the maximum <code>100</code>, and seek to not overstep your rate limit, you probably want to use a custom pattern for traversing large lists.</p>
<h2 id="working-with-github-enterprise">Working with GitHub Enterprise</h2>
<p>With a bit of setup, you can also use Octokit with your Github Enterprise instance.</p>
<h3 id="interacting-with-the-github.com-apis-in-github-enterprise">Interacting with the GitHub.com APIs in GitHub Enterprise</h3>
<p>To interact with the “regular” GitHub.com APIs in GitHub Enterprise, simply configure the <code>api_endpoint</code> to match your hostname. For example:</p>
<div class="sourceCode" id="cb22"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb22-1" title="1"><span class="dt">Octokit</span>.configure <span class="kw">do</span> |c|</a>
<a class="sourceLine" id="cb22-2" title="2">  c.api_endpoint = <span class="st">&quot;https://&lt;hostname&gt;/api/v3/&quot;</span></a>
<a class="sourceLine" id="cb22-3" title="3"><span class="kw">end</span></a>
<a class="sourceLine" id="cb22-4" title="4"></a>
<a class="sourceLine" id="cb22-5" title="5">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new(<span class="st">:access_token</span> =&gt; <span class="st">&quot;&lt;your 40 char token&gt;&quot;</span>)</a></code></pre></div>
<h3 id="interacting-with-the-github-enterprise-admin-apis">Interacting with the GitHub Enterprise Admin APIs</h3>
<p>The GitHub Enterprise Admin APIs are under a different client: <code>EnterpriseAdminClient</code>. You’ll need to have an administrator account in order to use these APIs.</p>
<div class="sourceCode" id="cb23"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb23-1" title="1">admin_client = <span class="dt">Octokit</span>::<span class="dt">EnterpriseAdminClient</span>.new(</a>
<a class="sourceLine" id="cb23-2" title="2">  <span class="st">:access_token</span> =&gt; <span class="st">&quot;&lt;your 40 char token&gt;&quot;</span>,</a>
<a class="sourceLine" id="cb23-3" title="3">  <span class="st">:api_endpoint</span> =&gt; <span class="st">&quot;https://&lt;hostname&gt;/api/v3/&quot;</span></a>
<a class="sourceLine" id="cb23-4" title="4">)</a>
<a class="sourceLine" id="cb23-5" title="5"></a>
<a class="sourceLine" id="cb23-6" title="6"><span class="co"># or</span></a>
<a class="sourceLine" id="cb23-7" title="7"><span class="dt">Octokit</span>.configure <span class="kw">do</span> |c|</a>
<a class="sourceLine" id="cb23-8" title="8">  c.api_endpoint = <span class="st">&quot;https://&lt;hostname&gt;/api/v3/&quot;</span></a>
<a class="sourceLine" id="cb23-9" title="9">  c.access_token = <span class="st">&quot;&lt;your 40 char token&gt;&quot;</span></a>
<a class="sourceLine" id="cb23-10" title="10"><span class="kw">end</span></a>
<a class="sourceLine" id="cb23-11" title="11"></a>
<a class="sourceLine" id="cb23-12" title="12">admin_client = <span class="dt">Octokit</span>.enterprise_admin_client.new</a></code></pre></div>
<h3 id="interacting-with-the-github-enterprise-management-console-apis">Interacting with the GitHub Enterprise Management Console APIs</h3>
<p>The GitHub Enterprise Management Console APIs are also under a separate client: <code>EnterpriseManagementConsoleClient</code>. In order to use it, you’ll need to provide both your management console password as well as the endpoint to your management console. This is different than the API endpoint provided above.</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb24-1" title="1">management_console_client = <span class="dt">Octokit</span>::<span class="dt">EnterpriseManagementConsoleClient</span>.new(</a>
<a class="sourceLine" id="cb24-2" title="2">  <span class="st">:management_console_password</span> =&gt; <span class="st">&quot;secret&quot;</span>,</a>
<a class="sourceLine" id="cb24-3" title="3">  <span class="st">:management_console_endpoint</span> = <span class="st">&quot;https://hostname:8633&quot;</span></a>
<a class="sourceLine" id="cb24-4" title="4">)</a>
<a class="sourceLine" id="cb24-5" title="5"></a>
<a class="sourceLine" id="cb24-6" title="6"><span class="co"># or</span></a>
<a class="sourceLine" id="cb24-7" title="7"><span class="dt">Octokit</span>.configure <span class="kw">do</span> |c|</a>
<a class="sourceLine" id="cb24-8" title="8">  c.management_console_endpoint = <span class="st">&quot;https://hostname:8633&quot;</span></a>
<a class="sourceLine" id="cb24-9" title="9">  c.management_console_password = <span class="st">&quot;secret&quot;</span></a>
<a class="sourceLine" id="cb24-10" title="10"><span class="kw">end</span></a>
<a class="sourceLine" id="cb24-11" title="11"></a>
<a class="sourceLine" id="cb24-12" title="12">management_console_client = <span class="dt">Octokit</span>.enterprise_management_console_client.new</a></code></pre></div>
<h3 id="ssl-connection-errors">SSL Connection Errors</h3>
<p>You <em>may</em> need to disable SSL temporarily while first setting up your GitHub Enterprise install. You can do that with the following configuration:</p>
<div class="sourceCode" id="cb25"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb25-1" title="1">client.connection_options[<span class="st">:ssl</span>] = { <span class="st">:verify</span> =&gt; <span class="dv">false</span> }</a></code></pre></div>
<p>Do remember to turn <code>:verify</code> back to <code>true</code>, as it’s important for secure communication.</p>
<h2 id="configuration-and-defaults">Configuration and defaults</h2>
<p>While <code>Octokit::Client</code> accepts a range of options when creating a new client instance, Octokit’s configuration API allows you to set your configuration options at the module level. This is particularly handy if you’re creating a number of client instances based on some shared defaults. Changing options affects new instances only and will not modify existing <code>Octokit::Client</code> instances created with previous options.</p>
<h3 id="configuring-module-defaults">Configuring module defaults</h3>
<p>Every writable attribute in {Octokit::Configurable} can be set one at a time:</p>
<div class="sourceCode" id="cb26"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb26-1" title="1"><span class="dt">Octokit</span>.api_endpoint = <span class="st">&#39;http://api.github.dev&#39;</span></a>
<a class="sourceLine" id="cb26-2" title="2"><span class="dt">Octokit</span>.web_endpoint = <span class="st">&#39;http://github.dev&#39;</span></a></code></pre></div>
<p>or in batch:</p>
<div class="sourceCode" id="cb27"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb27-1" title="1"><span class="dt">Octokit</span>.configure <span class="kw">do</span> |c|</a>
<a class="sourceLine" id="cb27-2" title="2">  c.api_endpoint = <span class="st">&#39;http://api.github.dev&#39;</span></a>
<a class="sourceLine" id="cb27-3" title="3">  c.web_endpoint = <span class="st">&#39;http://github.dev&#39;</span></a>
<a class="sourceLine" id="cb27-4" title="4"><span class="kw">end</span></a></code></pre></div>
<h3 id="using-env-variables">Using ENV variables</h3>
<p>Default configuration values are specified in {Octokit::Default}. Many attributes will look for a default value from the ENV before returning Octokit’s default.</p>
<div class="sourceCode" id="cb28"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb28-1" title="1"><span class="co"># Given $OCTOKIT_API_ENDPOINT is &quot;http://api.github.dev&quot;</span></a>
<a class="sourceLine" id="cb28-2" title="2">client.api_endpoint</a>
<a class="sourceLine" id="cb28-3" title="3"></a>
<a class="sourceLine" id="cb28-4" title="4"><span class="co"># =&gt; &quot;http://api.github.dev&quot;</span></a></code></pre></div>
<p>Deprecation warnings and API endpoints in development preview warnings are printed to STDOUT by default, these can be disabled by setting the ENV <code>OCTOKIT_SILENT=true</code>.</p>
<h2 id="hypermedia-agent">Hypermedia agent</h2>
<p>Starting in version 2.0, Octokit is <a href="http://en.wikipedia.org/wiki/Hypermedia">hypermedia</a>-enabled. Under the hood, {Octokit::Client} uses <a href="https://github.com/lostisland/sawyer">Sawyer</a>, a hypermedia client built on <a href="https://github.com/lostisland/faraday">Faraday</a>.</p>
<h3 id="hypermedia-in-octokit">Hypermedia in Octokit</h3>
<p>Resources returned by Octokit methods contain not only data but hypermedia link relations:</p>
<div class="sourceCode" id="cb29"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb29-1" title="1">user = client.user <span class="st">&#39;technoweenie&#39;</span></a>
<a class="sourceLine" id="cb29-2" title="2"></a>
<a class="sourceLine" id="cb29-3" title="3"><span class="co"># Get the repos rel, returned from the API</span></a>
<a class="sourceLine" id="cb29-4" title="4"><span class="co"># as repos_url in the resource</span></a>
<a class="sourceLine" id="cb29-5" title="5">user.rels[<span class="st">:repos</span>].href</a>
<a class="sourceLine" id="cb29-6" title="6"><span class="co"># =&gt; &quot;https://api.github.com/users/technoweenie/repos&quot;</span></a>
<a class="sourceLine" id="cb29-7" title="7"></a>
<a class="sourceLine" id="cb29-8" title="8">repos = user.rels[<span class="st">:repos</span>].get.data</a>
<a class="sourceLine" id="cb29-9" title="9">repos.last.name</a>
<a class="sourceLine" id="cb29-10" title="10"><span class="co"># =&gt; &quot;faraday-zeromq&quot;</span></a></code></pre></div>
<p>When processing API responses, all <code>*_url</code> attributes are culled in to the link relations collection. Any <code>url</code> attribute becomes <code>.rels[:self]</code>.</p>
<h3 id="uri-templates">URI templates</h3>
<p>You might notice many link relations have variable placeholders. Octokit supports <a href="http://tools.ietf.org/html/rfc6570">URI Templates</a> for parameterized URI expansion:</p>
<div class="sourceCode" id="cb30"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb30-1" title="1">repo = client.repo <span class="st">&#39;pengwynn/pingwynn&#39;</span></a>
<a class="sourceLine" id="cb30-2" title="2">rel = repo.rels[<span class="st">:issues</span>]</a>
<a class="sourceLine" id="cb30-3" title="3"><span class="co"># =&gt; #&lt;Sawyer::Relation: issues: get https://api.github.com/repos/pengwynn/pingwynn/issues{/number}&gt;</span></a>
<a class="sourceLine" id="cb30-4" title="4"></a>
<a class="sourceLine" id="cb30-5" title="5"><span class="co"># Get a page of issues</span></a>
<a class="sourceLine" id="cb30-6" title="6">rel.get.data</a>
<a class="sourceLine" id="cb30-7" title="7"></a>
<a class="sourceLine" id="cb30-8" title="8"><span class="co"># Get issue #2</span></a>
<a class="sourceLine" id="cb30-9" title="9">rel.get(<span class="st">:uri</span> =&gt; {<span class="st">:number</span> =&gt; <span class="dv">2</span>}).data</a></code></pre></div>
<h3 id="the-full-hypermedia-experience">The Full Hypermedia Experience™</h3>
<p>If you want to use Octokit as a pure hypermedia API client, you can start at the API root and follow link relations from there:</p>
<div class="sourceCode" id="cb31"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb31-1" title="1">root = client.root</a>
<a class="sourceLine" id="cb31-2" title="2">root.rels[<span class="st">:repository</span>].get <span class="st">:uri</span> =&gt; {<span class="st">:owner</span> =&gt; <span class="st">&quot;octokit&quot;</span>, <span class="st">:repo</span> =&gt; <span class="st">&quot;octokit.rb&quot;</span> }</a>
<a class="sourceLine" id="cb31-3" title="3">root.rels[<span class="st">:user_repositories</span>].get <span class="st">:uri</span> =&gt; { <span class="st">:user</span> =&gt; <span class="st">&quot;octokit&quot;</span> },</a>
<a class="sourceLine" id="cb31-4" title="4">                                  <span class="st">:query</span> =&gt; { <span class="st">:type</span> =&gt; <span class="st">&quot;owner&quot;</span> }</a></code></pre></div>
<p>Octokit 3.0 aims to be hypermedia-driven, removing the internal URL construction currently used throughout the client.</p>
<h2 id="upgrading-guide">Upgrading guide</h2>
<p>Version 4.0</p>
<ul>
<li><strong>removes support for a <a href="https://github.com/octokit/octokit.rb/commit/e48e91f736d5fce51e3bf74d7c9022aaa52f5c5c">long-deprecated overload</a> for passing state as a positional argument</strong> when listing pull requests. Instead, pass <code>state</code> in the method options.</li>
<li><strong>drops support for Ruby &lt; 2.0</strong>.</li>
<li>adds support for new <a href="#working-with-github-enterprise">Enterprise-only APIs</a>.</li>
<li>adds support for <a href="https://developer.github.com/changes/2015-05-26-repository-redirects-are-coming/">Repository redirects</a>.</li>
</ul>
<p>Version 3.0 includes a couple breaking changes when upgrading from v2.x.x:</p>
<p>The <a href="https://developer.github.com/changes/2014-01-07-upcoming-change-to-default-media-type/">default media type</a> is now <code>v3</code> instead of <code>beta</code>. If you need to request the older media type, you can set the default media type for the client:</p>
<div class="sourceCode" id="cb32"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb32-1" title="1"><span class="dt">Octokit</span>.default_media_type = <span class="st">&quot;application/vnd.github.beta+json&quot;</span></a></code></pre></div>
<p>or per-request</p>
<div class="sourceCode" id="cb33"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb33-1" title="1">client.emails(<span class="st">:accept</span> =&gt; <span class="st">&quot;application/vnd.github.beta+json&quot;</span>)</a></code></pre></div>
<p>The long-deprecated <code>Octokit::Client#create_download</code> method has been removed.</p>
<h3 id="upgrading-from-1.x.x">Upgrading from 1.x.x</h3>
<p>Version 2.0 includes a completely rewritten <code>Client</code> factory that now memoizes client instances based on unique configuration options. Breaking changes also include:</p>
<ul>
<li><code>:oauth_token</code> is now <code>:access_token</code></li>
<li><code>:auto_traversal</code> is now <code>:auto_paginate</code></li>
<li><code>Hashie::Mash</code> has been removed. Responses now return a <code>Sawyer::Resource</code> object. This new type behaves mostly like a Ruby <code>Hash</code>, but does not fully support the <code>Hashie::Mash</code> API.</li>
<li>Two new client error types are raised where appropriate: <code>Octokit::TooManyRequests</code> and <code>Octokit::TooManyLoginAttempts</code></li>
<li>The <code>search_*</code> methods from v1.x are now found at <code>legacy_search_*</code></li>
<li>Support for netrc requires including the <a href="https://rubygems.org/gems/netrc">netrc gem</a> in your Gemfile or gemspec.</li>
<li>DateTime fields are now proper <code>DateTime</code> objects. Previous versions outputted DateTime fields as ‘String’ objects.</li>
</ul>
<h2 id="advanced-usage">Advanced usage</h2>
<p>Since Octokit employs <a href="https://github.com/lostisland/faraday">Faraday</a> under the hood, some behavior can be extended via middleware.</p>
<h3 id="debugging">Debugging</h3>
<p>Often, it helps to know what Octokit is doing under the hood. You can add a logger to the middleware that enables you to peek into the underlying HTTP traffic:</p>
<div class="sourceCode" id="cb34"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb34-1" title="1">stack = <span class="dt">Faraday</span>::<span class="dt">RackBuilder</span>.new <span class="kw">do</span> |builder|</a>
<a class="sourceLine" id="cb34-2" title="2">  builder.use <span class="dt">Faraday</span>::<span class="dt">Request</span>::<span class="dt">Retry</span>, <span class="st">exceptions: </span>[<span class="dt">Octokit</span>::<span class="dt">ServerError</span>]</a>
<a class="sourceLine" id="cb34-3" title="3">  builder.use <span class="dt">Octokit</span>::<span class="dt">Middleware</span>::<span class="dt">FollowRedirects</span></a>
<a class="sourceLine" id="cb34-4" title="4">  builder.use <span class="dt">Octokit</span>::<span class="dt">Response</span>::<span class="dt">RaiseError</span></a>
<a class="sourceLine" id="cb34-5" title="5">  builder.use <span class="dt">Octokit</span>::<span class="dt">Response</span>::<span class="dt">FeedParser</span></a>
<a class="sourceLine" id="cb34-6" title="6">  builder.response <span class="st">:logger</span></a>
<a class="sourceLine" id="cb34-7" title="7">  builder.adapter <span class="dt">Faraday</span>.default_adapter</a>
<a class="sourceLine" id="cb34-8" title="8"><span class="kw">end</span></a>
<a class="sourceLine" id="cb34-9" title="9"><span class="dt">Octokit</span>.middleware = stack</a>
<a class="sourceLine" id="cb34-10" title="10"></a>
<a class="sourceLine" id="cb34-11" title="11">client = <span class="dt">Octokit</span>::<span class="dt">Client</span>.new</a>
<a class="sourceLine" id="cb34-12" title="12">client.user <span class="st">&#39;pengwynn&#39;</span></a></code></pre></div>
<pre><code>I, [2013-08-22T15:54:38.583300 #88227]  INFO -- : get https://api.github.com/users/pengwynn
D, [2013-08-22T15:54:38.583401 #88227] DEBUG -- request: Accept: &quot;application/vnd.github.beta+json&quot;
User-Agent: &quot;Octokit Ruby Gem 2.0.0.rc4&quot;
I, [2013-08-22T15:54:38.843313 #88227]  INFO -- Status: 200
D, [2013-08-22T15:54:38.843459 #88227] DEBUG -- response: server: &quot;GitHub.com&quot;
date: &quot;Thu, 22 Aug 2013 20:54:40 GMT&quot;
content-type: &quot;application/json; charset=utf-8&quot;
transfer-encoding: &quot;chunked&quot;
connection: &quot;close&quot;
status: &quot;200 OK&quot;
x-ratelimit-limit: &quot;60&quot;
x-ratelimit-remaining: &quot;39&quot;
x-ratelimit-reset: &quot;1377205443&quot;
...</code></pre>
<p>See the <a href="https://github.com/lostisland/faraday">Faraday README</a> for more middleware magic.</p>
<h3 id="caching">Caching</h3>
<p>If you want to boost performance, stretch your API rate limit, or avoid paying the hypermedia tax, you can use <a href="https://github.com/plataformatec/faraday-http-cache">Faraday Http Cache</a>.</p>
<p>Add the gem to your Gemfile</p>
<pre><code>gem &#39;faraday-http-cache&#39;</code></pre>
<p>Next, construct your own Faraday middleware:</p>
<div class="sourceCode" id="cb37"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb37-1" title="1">stack = <span class="dt">Faraday</span>::<span class="dt">RackBuilder</span>.new <span class="kw">do</span> |builder|</a>
<a class="sourceLine" id="cb37-2" title="2">  builder.use <span class="dt">Faraday</span>::<span class="dt">HttpCache</span>, <span class="st">serializer: </span><span class="dt">Marshal</span>, <span class="st">shared_cache: </span><span class="dv">false</span></a>
<a class="sourceLine" id="cb37-3" title="3">  builder.use <span class="dt">Octokit</span>::<span class="dt">Response</span>::<span class="dt">RaiseError</span></a>
<a class="sourceLine" id="cb37-4" title="4">  builder.adapter <span class="dt">Faraday</span>.default_adapter</a>
<a class="sourceLine" id="cb37-5" title="5"><span class="kw">end</span></a>
<a class="sourceLine" id="cb37-6" title="6"><span class="dt">Octokit</span>.middleware = stack</a></code></pre></div>
<p>Once configured, the middleware will store responses in cache based on ETag fingerprint and serve those back up for future <code>304</code> responses for the same resource. See the <a href="https://github.com/plataformatec/faraday-http-cache">project README</a> for advanced usage.</p>
<h2 id="hacking-on-octokit.rb">Hacking on Octokit.rb</h2>
<p>If you want to hack on Octokit locally, we try to make <a href="http://wynnnetherland.com/linked/2013012801/bootstrapping-consistency">bootstrapping the project</a> as painless as possible. To start hacking, clone and run:</p>
<pre><code>script/bootstrap</code></pre>
<p>This will install project dependencies and get you up and running. If you want to run a Ruby console to poke on Octokit, you can crank one up with:</p>
<pre><code>script/console</code></pre>
<p>Using the scripts in <code>./scripts</code> instead of <code>bundle exec rspec</code>, <code>bundle console</code>, etc. ensures your dependencies are up-to-date.</p>
<h3 id="running-and-writing-new-tests">Running and writing new tests</h3>
<p>Octokit uses <a href="https://github.com/vcr/vcr">VCR</a> for recording and playing back API fixtures during test runs. These cassettes (fixtures) are part of the Git project in the <code>spec/cassettes</code> folder. If you’re not recording new cassettes you can run the specs with existing cassettes with:</p>
<pre><code>script/test</code></pre>
<p>Octokit uses environmental variables for storing credentials used in testing. If you are testing an API endpoint that doesn’t require authentication, you can get away without any additional configuration. For the most part, tests use an authenticated client, using a token stored in <code>ENV['OCTOKIT_TEST_GITHUB_TOKEN']</code>. There are several different authenticating method’s used across the api. Here is the full list of configurable environmental variables for testing Octokit:</p>
<table>
<colgroup>
<col style="width: 52%" />
<col style="width: 47%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">ENV Variable</th>
<th style="text-align: left;">Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_LOGIN</code></td>
<td style="text-align: left;">GitHub login name (preferably one created specifically for testing against).</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_PASSWORD</code></td>
<td style="text-align: left;">Password for the test GitHub login.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_TOKEN</code></td>
<td style="text-align: left;"><a href="https://github.com/blog/1509-personal-api-tokens">Personal Access Token</a> for the test GitHub login.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_CLIENT_ID</code></td>
<td style="text-align: left;">Test OAuth application client id.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_CLIENT_SECRET</code></td>
<td style="text-align: left;">Test OAuth application client secret.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_REPOSITORY</code></td>
<td style="text-align: left;">Test repository to perform destructive actions against, this should not be set to any repository of importance. <strong>Automatically created by the test suite if nonexistent</strong> Default: <code>api-sandbox</code></td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ORGANIZATION</code></td>
<td style="text-align: left;">Test organization.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ENTERPRISE_LOGIN</code></td>
<td style="text-align: left;">GitHub Enterprise login name.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ENTERPRISE_TOKEN</code></td>
<td style="text-align: left;">GitHub Enterprise token.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ENTERPRISE_MANAGEMENT_CONSOLE_PASSWORD</code></td>
<td style="text-align: left;">GitHub Enterprise management console password.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ENTERPRISE_ENDPOINT</code></td>
<td style="text-align: left;">GitHub Enterprise hostname.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_ENTERPRISE_MANAGEMENT_CONSOLE_ENDPOINT</code></td>
<td style="text-align: left;">GitHub Enterprise Management Console endpoint.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_INTEGRATION</code></td>
<td style="text-align: left;"><a href="https://developer.github.com/early-access/integrations/">GitHub Integration</a> owned by your test organization.</td>
</tr>
<tr class="even">
<td style="text-align: left;"><code>OCTOKIT_TEST_GITHUB_INTEGRATION_INSTALLATION</code></td>
<td style="text-align: left;">Installation of the GitHub Integration specified above.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"><code>OCTOKIT_TEST_INTEGRATION_PEM_KEY</code></td>
<td style="text-align: left;">File path to the private key generated from your integration.</td>
</tr>
</tbody>
</table>
<p>Since we periodically refresh our cassettes, please keep some points in mind when writing new specs.</p>
<ul>
<li><strong>Specs should be idempotent</strong>. The HTTP calls made during a spec should be able to be run over and over. This means deleting a known resource prior to creating it if the name has to be unique.</li>
<li><strong>Specs should be able to be run in random order.</strong> If a spec depends on another resource as a fixture, make sure that’s created in the scope of the spec and not depend on a previous spec to create the data needed.</li>
<li><strong>Do not depend on authenticated user info.</strong> Instead of asserting actual values in resources, try to assert the existence of a key or that a response is an Array. We’re testing the client, not the API.</li>
</ul>
<h2 id="supported-ruby-versions">Supported Ruby Versions</h2>
<p>This library aims to support and is <a href="https://travis-ci.org/octokit/octokit.rb">tested against</a> the following Ruby implementations:</p>
<ul>
<li>Ruby 2.0</li>
<li>Ruby 2.1</li>
<li>Ruby 2.2</li>
<li>Ruby 2.3</li>
<li>Ruby 2.4</li>
<li>Ruby 2.5</li>
</ul>
<p>If something doesn’t work on one of these Ruby versions, it’s a bug.</p>
<p>This library may inadvertently work (or seem to work) on other Ruby implementations, but support will only be provided for the versions listed above.</p>
<p>If you would like this library to support another Ruby version, you may volunteer to be a maintainer. Being a maintainer entails making sure all tests run and pass on that implementation. When something breaks on your implementation, you will be responsible for providing patches in a timely fashion. If critical issues for a particular implementation exist at the time of a major release, support for that Ruby version may be dropped.</p>
<h2 id="versioning">Versioning</h2>
<p>This library aims to adhere to <a href="http://semver.org/">Semantic Versioning 2.0.0</a>. Violations of this scheme should be reported as bugs. Specifically, if a minor or patch version is released that breaks backward compatibility, that version should be immediately yanked and/or a new version should be immediately released that restores compatibility. Breaking changes to the public API will only be introduced with new major versions. As a result of this policy, you can (and should) specify a dependency on this gem using the <a href="http://guides.rubygems.org/patterns/#pessimistic-version-constraint">Pessimistic Version Constraint</a> with two digits of precision. For example:</p>
<pre><code>spec.add_dependency &#39;octokit&#39;, &#39;~&gt; 3.0&#39;</code></pre>
<p>The changes made between versions can be seen on the <a href="https://github.com/octokit/octokit.rb/releases">project releases page</a>.</p>
<h2 id="making-repeating-requests">Making Repeating Requests</h2>
<p>In most cases it would be best to use a <a href="https://developer.github.com/webhooks/">webhooks</a>, but sometimes webhooks don’t provide all of the information needed. In those cases where one might need to poll for progress or retry a request on failure, we designed <a href="https://github.com/octokit/octopoller.rb">Octopoller</a>. Octopoller is a micro gem perfect for making repeating requests.</p>
<div class="sourceCode" id="cb42"><pre class="sourceCode ruby"><code class="sourceCode ruby"><a class="sourceLine" id="cb42-1" title="1"><span class="dt">Octopoller</span>.poll(<span class="st">timeout: </span><span class="dv">15</span>.seconds) <span class="kw">do</span></a>
<a class="sourceLine" id="cb42-2" title="2">  <span class="kw">begin</span></a>
<a class="sourceLine" id="cb42-3" title="3">    client.request_progress <span class="co"># ex. request a long running job&#39;s status</span></a>
<a class="sourceLine" id="cb42-4" title="4">  <span class="kw">rescue</span> <span class="dt">Error</span></a>
<a class="sourceLine" id="cb42-5" title="5">    <span class="st">:re_poll</span></a>
<a class="sourceLine" id="cb42-6" title="6">  <span class="kw">end</span></a>
<a class="sourceLine" id="cb42-7" title="7"><span class="kw">end</span></a></code></pre></div>
<p>This is useful when making requests for a long running job’s progress (ex. requesting a <a href="https://developer.github.com/v3/migrations/source_imports/#get-import-progress">Source Import’s progress</a>).</p>
<h2 id="license">License</h2>
<p>Copyright (c) 2009-2014 Wynn Netherland, Adam Stacoviak, Erik Michaels-Ober</p>
<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>
<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>
<p>THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.</p>
